Fixed version reported when run from Git (issue #55)
[grml-debootstrap.git] / grml-debootstrap
index 96277b0..2a27c46 100755 (executable)
@@ -5,39 +5,48 @@
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2+
 ################################################################################
-# http://www.debian.org/releases/stable/i386/index.html.en
 
 # variables {{{
-PN="$(basename $0)"
-VERSION="$(dpkg --list $PN 2>/dev/null| awk '/^i/ {print $3}')"
+PN="$(basename "$0")"
+if [[ -d "$(dirname "$(which "$0")")"/.git ]]; then
+  VERSION="$(git describe | sed 's|^v||')"
+else
+  VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
+fi
 VERSION="${VERSION:-unknown}"
 MNTPOINT="/mnt/debootstrap.$$"
 
 # defaults
-CHROOT_SCRIPTS='yes'
-CONFFILES='/etc/debootstrap'
-DEBCONF='yes'
-DEBIAN_FRONTEND='noninteractive'
-DEBOOTSTRAP='debootstrap'
-EXTRAPACKAGES='yes'
-FORCE=''
-HOSTNAME='grml'
-INITRD='yes'
-INSTALL_NOTES='/etc/debootstrap/install_notes'
-LOCALES='yes'
-MIRROR='http://cdn.debian.net/debian'
-MKFS='mkfs.ext3'
-PACKAGES='yes'
-PRE_SCRIPTS='yes'
-RECONFIGURE='console-data'
-RELEASE='squeeze'
-RM_APTCACHE='yes'
-SCRIPTS='yes'
-SECURE='yes'
-TIMEZONE='Europe/Vienna'
-TUNE2FS='tune2fs -c0 -i0'
-UPGRADE_SYSTEM='yes'
-VMSIZE="2G"
+[ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
+[ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
+[ -n "$DEBCONF" ] || DEBCONF='yes'
+[ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
+[ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
+[ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
+[ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
+[ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
+[ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
+[ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://http.debian.net/debian'
+[ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
+[ -n "$FORCE" ] || FORCE=''
+[ -n "$HOSTNAME" ] || HOSTNAME='grml'
+[ -n "$INITRD" ] || INITRD='yes'
+[ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
+[ -n "$LOCALES" ] || LOCALES='yes'
+[ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
+[ -n "$MKFS" ] || MKFS='mkfs.ext4'
+[ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
+[ -n "$PACKAGES" ] || PACKAGES='yes'
+[ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
+[ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
+[ -n "$RELEASE" ] || RELEASE='jessie'
+[ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
+[ -n "$SCRIPTS" ] || SCRIPTS='yes'
+[ -n "$SECURE" ] || SECURE='yes'
+[ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
+[ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
+[ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
+[ -n "$VMSIZE" ] || VMSIZE="2G"
 
 # inside the chroot system locales might not be available, so use minimum:
 export LANG=C
@@ -59,7 +68,7 @@ Bootstrap options:
   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
                          instead of fetching packages from a mirror.
-  -r, --release <name>   Release of new Debian system (default: squeeze).
+  -r, --release <name>   Release of new Debian system (default: jessie).
   -t, --target <target>  Target partition (/dev/...) or directory where the
                          system should be installed to.
   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
@@ -71,14 +80,15 @@ Bootstrap options:
       --arch <arch>      Set target architecture, use for installing i386 on amd64.
       --filesystem <fs>  Filesystem that should be used when target is a partition
                          or Virtual Machine (see --vmfile).
-      --insecure         Do not download and check Release file signatures.
       --force            Do not prompt for user acknowledgement.
 
 Options for Virtual Machine deployment:
 
-      --vmfile           Set up a Virtual Machine instead of installing to
-                         a partition or directory, to be combined with --target,
-                         like: --vmfile --target /mnt/sda1/qemu.img
+      --vm               Set up a Virtual Machine, instead of plainly installing
+                         to a partition or directory, to be combined with --target,
+                         like: --vm --target /dev/mapper/your-vm-disk
+      --vmfile           Like --vm, but install into a file (raw format).
+                         Example: --vmfile --target /mnt/sda1/qemu.img
       --vmsize <size>    Use specified size for size of VM file (default: 2G).
                          Syntax as supported by qemu-img, like: --vmsize 3G
 
@@ -92,8 +102,15 @@ Configuration options:
                              instead of using /etc/debootstrap/packages.
       --nopackages         Skip installation of packages defined in
                              /etc/debootstrap/packages
+      --nokernel           Skip installation of default kernel images.
+      --nointerfaces       Do not copy /etc/network/interfaces from host system
+                           to target system.
+                           (This option is automatically enabled when using --vmfile.)
+      --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
+                           DHCP for eth0) instead of taking over config from host system.
       --debconf <file>     Pre-seed packages using specified pre-seed db file.
       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
+      --backportrepos      Enable Debian's backports repository (backports.debian.org).
       --keep_src_list      Do not overwrite user provided apt sources.list.
       --hostname <name>    Hostname of Debian system.
       --nopassword         Do not prompt for the root password.
@@ -106,6 +123,7 @@ Configuration options:
 Other options:
 
   -v, --verbose            Increase verbosity.
+      --debug              Execute in very verbose way.
   -h, --help               Print this usage information and exit.
   -V, --version            Show summary of options and exit.
 
@@ -123,11 +141,8 @@ fi
 
 # early helper functions {{{
 GOOD='\e[32;01m'
-WARN='\e[33;01m'
 BAD='\e[31;01m'
 NORMAL='\e[0m'
-HILITE='\e[36;01m'
-BRACKET='\e[34;01m'
 
 einfo() {
   einfon "$1\n"
@@ -143,7 +158,7 @@ einfon() {
 
 eerror() {
   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
-  printf " ${BAD}*${NORMAL} $*\n"
+  printf " ${BAD}*${NORMAL} $*\n" >&2
   LAST_E_CMD=eerror
   return 0
 }
@@ -151,10 +166,10 @@ eerror() {
 eend() {
   local retval="${1:-0}"
   shift
-  if [ $retval -gt 0 ]; then
+  if [ "$retval" -gt 0 ]; then
     printf " ${BAD}-> Failed (rc=${retval})${NORMAL}\n"
   fi
-  return $retval
+  return "$retval"
 }
 
 check4root(){
@@ -165,8 +180,8 @@ check4root(){
 
 check4progs(){
   local RC=''
-  for arg in $* ; do
-    which $arg >/dev/null 2>&1 || RC="$arg"
+  for arg in "$@" ; do
+    which "$arg" >/dev/null 2>&1 || RC="$arg"
   done
   if [ -n "$RC" ] ; then
      echo "$RC not installed"
@@ -176,47 +191,78 @@ check4progs(){
 # }}}
 
 # helper functions {{{
-# we want to exit smoothly and clean:
-bailout(){
+cleanup() {
+  if [ -n "$CHROOT_VARIABLES" ] ; then
+    einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
+  fi
+
+  if [ -n "$STAGES" ] ; then
+    einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
+  fi
+
+  # Remove temporary mountpoint again
+  if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
+    rmdir "$MNTPOINT" 2>/dev/null
+  fi
+
   # make sure $TARGET is not mounted when exiting grml-debootstrap
   if [ -n "$MNTPOINT" ] ; then
-     if grep -q $MNTPOINT /proc/mounts ; then
-        # make sure nothing is left inside chroot so we can unmount it
-        [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
-        [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
-        # ugly, but make sure we really don't leave anything (/proc /proc is intended)
-        for ARG in /sys /proc /proc ; do
-          [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1 || true
-        done
-        umount "$MNTPOINT"/dev >/dev/null 2>&1 || true
-
-        [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1 || true
-
-        if [ -n "$DIRECTORY" ] ; then
-          einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
-        else
-          einfo "Unmounting $MNTPOINT" ; umount "$MNTPOINT" ; eend $?
+    if grep -q "$MNTPOINT" /proc/mounts ; then
+      # make sure nothing is left inside chroot so we can unmount it
+      for service in ssh mdadm ; do
+        if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
+          chroot "$MNTPOINT" "/etc/init.d/${service}" stop
         fi
+      done
 
-        if [ -n "$STAGES" ] ; then
-           echo -n "Removing stages directory ${STAGES}: "
-           rm -rf "$STAGES" && echo done
-        fi
+      [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
 
-        # remove directory only if we used the default with process id inside the name
-        if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
-           einfo "Removing directory ${MNTPOINT}" ; rmdir $MNTPOINT ; eend $?
-        fi
-     fi
+      # ugly, but make sure we really don't leave anything (/proc /proc and
+      # /dev /dev are intended, trying to work around timing issues, see #657023)
+      for ARG in /sys /proc /proc /dev /dev ; do
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
+        umount "$MNTPOINT"/$ARG >/dev/null 2>&1
+      done
+
+      if [ -n "$ISODIR" ] ; then
+        [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
+      fi
+
+      if [ -n "$DIRECTORY" ] ; then
+        einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
+      else
+        einfo "Unmounting $MNTPOINT"
+        umount "$MNTPOINT"
+        eend $?
+      fi
+
+      if [ -n "$STAGES" ] ; then
+        echo -n "Removing stages directory ${STAGES}: "
+        rm -rf "$STAGES" && echo 'done'
+      fi
+
+      # remove directory only if we used the default with process id inside the name
+      if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
+        einfo "Removing directory ${MNTPOINT}"
+        rmdir "$MNTPOINT"
+        eend $?
+      fi
+    fi
   fi
 
   if [ -n "${ORIG_TARGET}" ] ; then
     einfo "Removing loopback mount of file ${ORIG_TARGET}."
     kpartx -d "${ORIG_TARGET}" ; eend $?
   fi
+}
+
+# we want to exit smoothly and clean:
+bailout(){
+
+  cleanup
 
   [ -n "$1" ] && EXIT="$1" || EXIT="1"
-  [ -n "$3" ] && einfo "Notice: just remove $STAGES/$3 to reexecute the stage"
+  [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
 
   exit "$EXIT"
 }
@@ -227,7 +273,7 @@ stage() {
   if [ -n "$2" ] ; then
      echo "$2" > "${STAGES}/${1}"
      return 0
-  elif grep -q done "${STAGES}/${1}" 2>/dev/null ; then
+  elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
      ewarn "  To reexecute it clean up the according directory inside $STAGES" ; eend 0
      return 1
@@ -236,7 +282,7 @@ stage() {
 # }}}
 
 # make sure we have what we need {{{
-check4progs debootstrap dialog || exit 1
+check4progs debootstrap || bailout 1
 # }}}
 
 # source main configuration file {{{
@@ -254,7 +300,7 @@ elif [ -r /usr/share/grml-debootstrap/functions/cmdlineopts.clp ] ; then
 else
    eerror "Error: cmdline function file not found, exiting."
    eend 1
-   exit 1
+   bailout 1
 fi
 
 # == business-logic of command line parameter-processing
@@ -264,10 +310,10 @@ fi
   CONFFILES=$_opt_confdir
   einfo "Using config files under $CONFFILES/."
   if ! [ -r "$CONFFILES/config" ] ; then
-    eerror "Error: config file $CONFFILES/config not found."; eend 1; exit 1
+    eerror "Error: config file $CONFFILES/config not found."; eend 1; bailout 1
   fi
   if ! . "$CONFFILES/config" ; then
-    eerror "Error reading config file $CONFFILES/config" ; eend 1 ; exit 1
+    eerror "Error reading config file $CONFFILES/config" ; eend 1 ; bailout 1
   fi
   # restore the command line parameter value
   CONFFILES=$_opt_confdir
@@ -278,7 +324,8 @@ fi
 [ "$_opt_iso" ]                 && ISO=$_opt_iso
 [ "$_opt_release" ]             && RELEASE=$_opt_release
 [ "$_opt_target" ]              && TARGET=$_opt_target
-[ "$_opt_vmfile" ]              && VIRTUAL=1
+[ "$_opt_vm" ]                  && VIRTUAL=1
+[ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
@@ -293,15 +340,24 @@ fi
 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
+[ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
+[ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
+[ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
+[ "$_opt_nokernel" ]            && NOKERNEL="true"
 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
 [ "$_opt_grub" ]                && GRUB=$_opt_grub
 [ "$_opt_arch" ]                && ARCH=$_opt_arch
-[ "$_opt_insecure" ]            && SECURE='false'
+[ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
 [ "$_opt_force" ]               && FORCE=$_opt_force
 [ "$_opt_verbose" ]             && VERBOSE="-v"
+[ "$_opt_debug" ]               && DEBUG="true"
+
+if [ "$DEBUG" = "true" ] ; then
+  set -x
+fi
 
 [ "$_opt_help" ] && {
   usage ; eend 0
@@ -320,13 +376,13 @@ fi
 # check for root permissions {{{
 if ! check4root ; then
    echo "For usage instructions please execute '$PN --help'."
-   exit 1
+   bailout 1
 fi
 # }}}
 
 # make sure we have what we need {{{
 if [ -n "$VIRTUAL" ] ; then
-  check4progs kpartx mksh qemu-img || exit 1
+  check4progs grub-mkimage kpartx mksh parted qemu-img || bailout 1
 fi
 # }}}
 
@@ -334,7 +390,7 @@ fi
 if [ -n "$CONFIGFILE" ] ; then
    einfo "Reading specified config file $CONFIGFILE."
    if ! . "$CONFIGFILE" ; then
-      eerror "Error reading config file $CONFIGFILE" ; eend 1 ; exit 1
+      eerror "Error reading config file $CONFIGFILE" ; eend 1 ; bailout 1
    fi
 fi
 # }}}
@@ -345,14 +401,14 @@ if [ -n "$GROOT" ] ; then
    eerror "This variable is no longer supported, please visit the"
    eerror "grml-debootstrap documentation for details."
    eend 1
-   exit 1
+   bailout 1
 fi
 
 if echo "$GRUB" | grep -q '^hd' ; then
    eerror "Error: this syntax for the grub configuration variable is no longer supported."
    eerror "Please do not use hd... any longer but /dev/sdX instead."
    eend 1
-   exit 1
+   bailout 1
 fi
 # }}}
 
@@ -370,24 +426,27 @@ prompt_for_target()
   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
                sed 's/*//' | \
                grep -v 'Extended$' | \
-               gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md* 2>/dev/null || true);
+               gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
 
   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
      dialog --title "$PN" --trim \
      --msgbox "Sorry, no partitions found. Please configure your
      harddisks (see /proc/partitions) using a tool like fdisk,
      cfdisk, gpart, gparted,..." 0 0
-     exit 0
+     bailout 1
   fi
 
-  PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
-                       echo "$i $(blkid -s TYPE -o value $i 2>/dev/null || echo [no_filesystem_yet])"
+  PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
+                     fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
+                     [ -n "$fs" ] || fs='[no_filesystem_yet]'
+                     echo "$i" "$fs"
+                     unset fs
                    done)
 
   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
          --menu "Please select the target partition:" 0 0 0 \
          $PARTITION_LIST)
-  [ $? -eq 0 ] || bailout
+  [ $? -eq 0 ] || bailout 1
 }
 # }}}
 
@@ -403,23 +462,23 @@ prompt_for_bootmanager()
      found=
      for device in /dev/disk/by-id/*
      do
-        [ $(readlink -f $device) = ${TARGET} ] || continue
+        [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
         found=1
         break
      done
-     [ -n "$found" ] && MBRDISK=$(echo ${device}|sed -e 's/-part[0-9][0-9]*$//')
+     [ -n "$found" ] && MBRDISK=$(echo "${device}" |sed -e 's/-part[0-9][0-9]*$//')
      if [ -e "$MBRDISK" ]; then
-        MBRDISK=$(readlink -f $MBRDISK)
+        MBRDISK=$(readlink -f "$MBRDISK")
      else
         # fall back to old behaviour
-        MBRDISK=$(echo ${TARGET} | sed -e 's/[0-9][0-9]*$//')
+        MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
      fi
 
      MBRPART="MBR of $MBRDISK"
   fi
 
   for device in cciss/c0d0 sda hda; do
-    if [ /dev/$device != ${MBRDISK} ]; then
+    if [ "/dev/$device" != "${MBRDISK}" ]; then
       grep -q $device /proc/partitions && \
       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
     fi
@@ -440,12 +499,7 @@ prompt_for_bootmanager()
     mbr)
       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
       if echo "$TARGET" | grep -q "/dev/md" ; then
-         # using sw-raid:
-         if [ -n "$SELECTED_PARTITIONS" ] ; then
-            GRUB=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}') # use first disk only
-         else
-            GRUB="$TARGET"
-         fi
+        GRUB="$TARGET"
       else
         GRUB="$MBRDISK"
       fi
@@ -466,13 +520,14 @@ prompt_for_bootmanager()
 # ask for Debian release {{{
 prompt_for_release()
 {
-  [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='squeeze'
+  [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='jessie'
   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
             "Please enter the Debian release you would like to use for installation:" \
-            0 50 4 \
-            lenny    Debian/old-stable \
-            squeeze  Debian/stable \
-            wheezy   Debian/testing \
+            0 50 5 \
+            lenny    Debian/5.0 \
+            squeeze  Debian/6.0 \
+            wheezy   Debian/7.0 \
+            jessie   Debian/8.0 \
             sid      Debian/unstable)"
   [ $? -eq 0 ] || bailout
 }
@@ -483,7 +538,7 @@ prompt_for_hostname()
 {
   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
             "Please enter the hostname you would like to use for installation:" \
-            0 0 $HOSTNAME)"
+            0 0 "$HOSTNAME")"
   [ $? -eq 0 ] || bailout
 }
 # }}}
@@ -502,14 +557,15 @@ prompt_for_password()
     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
     "Please enter the password for the root account:" 10 60)
     [ $? -eq 0 ] || bailout
+
     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
     "Please enter the password for the root account again for \
     confirmation:" 10 60)
     [ $? -eq 0 ] || bailout
 
     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
-      $(dialog --stdout --title "${PN}" --ok-label \
-      "Retry" --msgbox "Passwords do not match!" 10 60)
+      dialog --stdout --title "${PN}" --ok-label \
+        "Retry" --msgbox "Passwords do not match!" 10 60
     fi
   done
   ROOTPASSWORD="$ROOTPW1"
@@ -529,7 +585,7 @@ prompt_for_mirror()
   [ $? -eq 0 ] || bailout
 
   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
-     [ -n "$MIRROR" ] || MIRROR='http://cdn.debian.net/debian'
+     [ -n "$MIRROR" ] || MIRROR='http://http.debian.net/debian'
      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
                "Please enter Debian mirror you would like to use for installing packages." \
                0 0 $MIRROR)"
@@ -552,14 +608,8 @@ TMPFILE=$(mktemp)
 # Currently we support only raid1:
 RAIDLEVEL='raid1'
 
-#RAIDLEVEL=$(dialog --stdout --title "$PN" --default-item raid1 \
-#                   --menu "Which RAID level do you want to use?" 0 0 0 \
-#                     raid1 "Software RAID level 1" \
-#                     raid5 "Software RAID level 5")
-#[ $? -eq 0 ] || bailout 20
-
 MD_LIST=$(for i in $(seq 0 9) ; do
-            awk '{print $4}' /proc/partitions | grep -q md$i || \
+            awk '{print $4}' /proc/partitions | grep -q "md$i" || \
             echo "/dev/md$i /dev/md$i"
           done)
 
@@ -574,26 +624,25 @@ AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
              sed 's/*//' | \
              grep -v 'Extended$' | \
              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
-[ -n "$AVAILABLE_PARTITIONS" ] || echo "FIXME: no partitions available?"
-PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
-                     echo "$i $(blkid -s TYPE -o value $i 2>/dev/null || echo [no_filesystem_yet]) off"
+[ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
+PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
+                     echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
                  done)
 
 dialog --title "$PN" --separate-output \
        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
-       $PARTITION_LIST 2>$TMPFILE
+       $PARTITION_LIST 2>"$TMPFILE"
 [ $? -eq 0 ] || bailout
-RETVAL=$?
-SELECTED_PARTITIONS="$(cat $TMPFILE)"
+SELECTED_PARTITIONS="$(cat "$TMPFILE")"
 
 NUM_PARTITIONS=0
-for i in $(cat $TMPFILE) ; do
-   NUM_PARTITIONS=$((${NUM_PARTITIONS}+1))
+for i in $(cat "$TMPFILE") ; do
+   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
 done
 
 # force metadata version 0.90 for lenny so old grub can boot from this array.
 METADATA_VERSION=""
-if [ $RELEASE = "lenny" ]; then
+if [ "$RELEASE" = "lenny" ]; then
    METADATA_VERSION="-e0"
 fi
 
@@ -609,11 +658,11 @@ else
    dialog --title "$PN" --msgbox \
    "There was an error setting up $TARGET:
 
-$(cat $ERRORFILE)
+$(cat "$ERRORFILE")
 
 Exiting." 0 0
    rm -f "$TMPFILE" "$ERRORFILE"
-   exit 1
+   bailout 1
 fi
 
 }
@@ -649,7 +698,7 @@ checkconfiguration()
 if [ -n "$AUTOINSTALL" ] ; then
    if checkforrun ; then
       eerror "Exiting as requested" ; eend 0
-      exit 1
+      bailout 1
    fi
 elif [ -n "$INTERACTIVE" ] ; then
 
@@ -662,11 +711,13 @@ elif [ -n "$INTERACTIVE" ] ; then
    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
    Using release:   $RELEASE"
    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
-   Using hostname   $HOSTNAME"
+   Using hostname:  $HOSTNAME"
    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
    Using mirror:    $MIRROR"
    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
    Using ISO:       $ISO"
+   [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
+   Using arch:      $ARCH"
 
    INFOTEXT="$INFOTEXT
 
@@ -677,7 +728,7 @@ Is this ok for you? Notice: selecting 'No' will exit ${PN}."
    [ $? -eq 0 ] || bailout 0
 
 else # if not running automatic installation display configuration and prompt for execution:
-   einfo "$PN - Please recheck configuration before execution:"
+   einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
    echo
    echo "   Target:          $TARGET"
 
@@ -691,12 +742,21 @@ else # if not running automatic installation display configuration and prompt fo
    fi
 
    [ -n "$RELEASE" ]  && echo "   Using release:   $RELEASE"
-   [ -n "$MIRROR" ]   && echo "   Using mirror:    $MIRROR"
    [ -n "$HOSTNAME" ] && echo "   Using hostname:  $HOSTNAME"
+   [ -n "$MIRROR" ]   && echo "   Using mirror:    $MIRROR"
    [ -n "$ISO" ]      && echo "   Using ISO:       $ISO"
+   [ -n "$ARCH" ]     && echo "   Using arch:      $ARCH"
    if [ -n "$VIRTUAL" ] ; then
       echo "   Deploying as Virtual Machine."
-      [ -n "$VMSIZE" ] && echo "   Using Virtual Disk file with size of ${VMSIZE}."
+      if [ -n "$VMSIZE" -a -n "$VMFILE" ]; then
+         echo "   Using Virtual Disk file with size of ${VMSIZE}."
+      fi
+   fi
+
+   if [ ! -t 0 -a -z "$ROOTPASSWORD" -a -z "$NOPASSWORD" ] ; then
+      echo
+      echo "   You do not have a TTY allocated, your password will be shown in"
+      echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
    fi
 
    echo
@@ -710,7 +770,7 @@ else # if not running automatic installation display configuration and prompt fo
      read a
      if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
         eerror "Exiting as requested." ; eend 1
-        exit 1
+        bailout 1
      fi
    fi
 fi
@@ -720,6 +780,8 @@ fi
 # interactive mode {{{
 interactive_mode()
 {
+  check4progs dialog || bailout 1
+
   welcome_dialog
 
   prompt_for_release
@@ -745,6 +807,35 @@ if [ -z "$TARGET" -o -n "$INTERACTIVE" ] ; then
 fi
 # }}}
 
+# architecture setup {{{
+if [ -n "$ARCH" ] ; then
+   ARCHCMD="--arch $ARCH"
+   ARCHINFO=" (${ARCH})"
+else
+   ARCH="$(dpkg --print-architecture)"
+   ARCHCMD="--arch $ARCH"
+   ARCHINFO=" (${ARCH})"
+fi
+# }}}
+
+# It is not possible to build amd64 on i686. {{{
+CURRENT_ARCH="$(uname -m)"
+if [ "$CURRENT_ARCH" != "x86_64" ] ; then
+   if [ "$ARCH" = "amd64" ] ; then
+      eerror "It is not possible to build amd64 on $CURRENT_ARCH." ; eend 1
+      bailout 1
+   fi
+fi
+# }}}
+
+# Support for generic release codenames is unavailable. {{{
+if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
+   eerror "Generic release codenames (stable, testing) are unsupported. \
+Please use specific codenames such as lenny, squeeze, wheezy or jessie." ; eend 1
+   bailout 1
+fi
+# }}}
+
 checkconfiguration
 
 # finally make sure at least $TARGET is set [the partition for the new system] {{{
@@ -753,7 +844,7 @@ if [ -n "$TARGET" ] ; then
 else
    eerror "Please adjust $CONFFILES/config or..."
    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
-   exit 1
+   bailout 1
 fi
 # }}}
 
@@ -764,7 +855,7 @@ if [ -z "$STAGES" ] ; then
 fi
 
 if [ -r "$STAGES"/grml-debootstrap ] ; then
-   if grep -q done $STAGES/grml-debootstrap ; then
+   if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
    fi
@@ -782,11 +873,10 @@ set_target_directory(){
     MKFS=''
     TUNE2FS=''
     FSCK=''
-    GRUB=''
     # make sure we normalise the path to an absolute directory name so something like:
     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
     # works
-    TARGET="$(readlink -f $TARGET)"
+    TARGET="$(readlink -f "$TARGET")"
 }
 
 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
@@ -796,37 +886,13 @@ else
 fi
 # }}}
 
-# architecture setup {{{
-if [ -n "$ARCH" ] ; then
-   ARCHCMD="--arch $ARCH"
-   ARCHINFO=" (${ARCH})"
-else
-   ARCH="$(dpkg --print-architecture)"
-   ARCHCMD="--arch $ARCH"
-   ARCHINFO=" (${ARCH})"
-fi
-# }}}
-
-# keyring setupt {{{
-KEYRING=""
-if [ "$SECURE" = 'yes' ] ; then
-   if [ -e '/etc/apt/trusted.gpg' ] ; then
-      KEYRING="--keyring /etc/apt/trusted.gpg"
-   else
-      eerror "Could not find /etc/apt/trusted.gpg."
-   fi
-else
-   ewarn "Not checking Release signatures!"
-fi
-# }}}
-
 # make sure we have the right syntax when using an iso image {{{
 if [ -n "$ISO" ] ; then
    case $ISO in
       file*) # do nothing
       ;;
       *)
-      ISO=file:$1
+      ISO=file:$ISO
       ;;
    esac
 fi
@@ -834,37 +900,67 @@ ISODIR=${ISO##file:}
 ISODIR=${ISODIR%%/}
 # }}}
 
+# Debian ISOs do not contain signed Release files {{{
+if [ -n "$ISO" ] ; then
+    DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
+fi
+# }}}
+
 # create filesystem {{{
 mkfs() {
   if [ -n "$DIRECTORY" ] ; then
      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
-  else
-    if grep -q "$TARGET" /proc/mounts ; then
-      eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
-      exit 1
-    fi
+     return 0
+  fi
 
-    if [ -n "$MKFS" ] ; then
-       einfo "Running $MKFS on $TARGET"
-       $MKFS $TARGET ; RC=$?
+  if grep -q "$TARGET" /proc/mounts ; then
+    eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
+    bailout 1
+  fi
 
-       # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
-       # will fail to detect the uuid in the chroot
-       if echo "$TARGET" | grep -q "/dev/md" ; then
-         blockdev --rereadpt "${TARGET}"
-       elif ! [ -n "$VIRTUAL" ] ; then
-         blockdev --rereadpt "${TARGET%%[0-9]*}"
-       fi
-       # give the system 2 seconds, otherwise we might run into
-       # race conditions :-/
-       sleep 2
+  # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
+  # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
+  if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
+    case "$MKFS" in
+      mkfs.ext*)
+        einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
+        MKFS_OPTS="$MKFS_OPTS -F"
+        eend 0
+        ;;
+    esac
+  fi
 
-       eval $(blkid -o udev $TARGET 2>/dev/null)
-       [ -n "$ID_FS_UUID" ] && TARGET_UUID="$ID_FS_UUID" || TARGET_UUID=""
+  if [ -n "$MKFS" ] ; then
+    einfo "Running $MKFS $MKFS_OPTS on $TARGET"
+    "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
 
-       eend $RC
+    if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
+      if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
+        eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
+        eend 1
+        bailout 1
+      else
+        einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
+        tune2fs "$TARGET" -U "$DISK_IDENTIFIER"
+        eend $?
+      fi
+    fi
+
+    # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
+    # will fail to detect the uuid in the chroot
+    if echo "$TARGET" | grep -q "/dev/md" ; then
+      blockdev --rereadpt "${TARGET}"
+    elif ! [ -n "$VIRTUAL" ] ; then
+      blockdev --rereadpt "${TARGET%%[0-9]*}"
     fi
+    # give the system 2 seconds, otherwise we might run into
+    # race conditions :-/
+    sleep 2
 
+    eval "$(blkid -o udev "$TARGET" 2>/dev/null)"
+    [ -n "$ID_FS_UUID" ] && TARGET_UUID="$ID_FS_UUID" || TARGET_UUID=""
+
+    eend $RC
   fi
 }
 # }}}
@@ -873,7 +969,7 @@ mkfs() {
 tunefs() {
   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
-     $TUNE2FS $TARGET
+     $TUNE2FS "$TARGET"
      eend $?
   fi
 }
@@ -884,7 +980,7 @@ mount_target() {
   if [ -n "$DIRECTORY" ] ; then
      einfo "Running grml-debootstrap on a directory, nothing to mount."
   else
-     if grep -q $TARGET /proc/mounts ; then
+     if grep -q "$TARGET" /proc/mounts ; then
         ewarn "$TARGET already mounted, continuing anyway." ; eend 0
      else
        if ! [ -d "${MNTPOINT}" ] ; then
@@ -892,7 +988,7 @@ mount_target() {
        fi
        einfo "Mounting $TARGET to $MNTPOINT"
        mkdir -p "$MNTPOINT"
-       mount -o rw,suid,dev $TARGET $MNTPOINT
+       mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
        eend $?
      fi
   fi
@@ -908,39 +1004,72 @@ mount_target() {
 # prepare VM image for usage with debootstrap {{{
 prepare_vm() {
   if [ -z "$VIRTUAL" ] ; then
-     return 0 # be quite by intention
+     return 0 # be quiet by intention
   fi
 
-  if [ -b "$TARGET" ] ; then
+  if [ -b "$TARGET" -a -n "$VMFILE" ] ; then
      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
      eend 1
-     exit 1
+     bailout 1
+  fi
+  if [ ! -b "$TARGET" -a -z "$VMFILE" ] ; then
+     eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
+     eend 1
+     bailout 1
   fi
 
   ORIG_TARGET="$TARGET" # store for later reuse
 
-  qemu-img create -f raw "${TARGET}" "${VMSIZE}"
+  if [ -n "$VMFILE" ]; then
+    qemu-img create -f raw "${TARGET}" "${VMSIZE}"
+  fi
   echo 4 66 | /usr/share/grml-debootstrap/bootgrub.mksh -A | dd of="$TARGET" conv=notrunc
   dd if=/dev/zero bs=1 conv=notrunc count=64 seek=446 of="$TARGET"
-  parted -s "${TARGET}" 'mkpart primary ext3 2M -1'
+  if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
+    einfo "Adjusting disk signature to a fixed (non-random) value"
+    MBRTMPFILE=$(mktemp)
+    dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
+    echo -en "\x41\x41\x41\x41\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
+    dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
+    eend $?
+  fi
+  parted -s "${TARGET}" 'mkpart primary ext4 2M -1'
+
+  # if dm-mod isn't available then kpartx will fail with
+  # "Is device-mapper driver missing from kernel? [...]"
+  if ! kpartx -av "$TARGET" >/dev/null 2>&1 || ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
+    einfo "Device-mapper not ready yet, trying to load dm-mod module."
+    modprobe dm-mod ; eend $?
+  fi
 
-  DEVINFO=$(kpartx -av $TARGET) # 'add map loop1p1 (253:0): 0 6289408 linear /dev/loop1 2048'
+  # make sure loop module is present
+  if ! losetup -f >/dev/null 2>&1; then
+    einfo "Can not find a usable loop device, retrying after loading loop module."
+    modprobe loop
+    if losetup -f >/dev/null 2>&1; then
+      einfo "Found a usable loop device now, continuing."
+    else
+      eerror "Error finding usable loop device" ; eend 1
+      bailout 1
+    fi
+  fi
+
+  DEVINFO=$(kpartx -asv "$TARGET") # 'add map loop1p1 (253:0): 0 6289408 linear /dev/loop1 2048'
   if [ -z "${DEVINFO}" ] ; then
     eerror "Error setting up loopback device." ; eend 1
-    exit 1
+    bailout 1
   fi
 
   # hopefully this always works as expected
-  LOOP=$(echo ${DEVINFO} | sed 's/.* linear //; s/ [[:digit:]]*//') # '/dev/loop1'
-  BLOCKDEV=$(echo "${DEVINFO}" | sed -e 's/.* (\(.*:.*\)).*/\1/')   # '253:0'
-  LOOP_PART="$(echo ${DEVINFO##add map } | sed 's/ .*//')" # '/dev/loop1p1'
+  LOOP=$(echo "${DEVINFO}" | sed 's/.* linear //; s/ [[:digit:]]*//') # 'loop1'
+  LOOP_PART="$(echo "${DEVINFO##add map }" | sed 's/ .*//')" # 'loop1p1'
   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop1p1'
 
   blockdev --rereadpt "${LOOP}"
 
   if [ -z "$TARGET" ] ; then
      eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
-     exit 1
+     bailout 1
   fi
 }
 # }}}
@@ -953,7 +1082,7 @@ finalize_vm() {
 
   if ! mount "${TARGET}" "${MNTPOINT}" ; then
     eerror "Error: Mounting ${TARGET} failed, can not continue." ; eend 1
-    exit 1
+    bailout 1
   fi
 
   einfo "Installing Grub as bootloader."
@@ -964,26 +1093,37 @@ finalize_vm() {
   mkdir -p "${MNTPOINT}/boot/grub"
   if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
      eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
-     exit 1
+     bailout 1
   fi
 
-  cp "${MNTPOINT}"/usr/lib/grub/i386-pc/* "${MNTPOINT}/boot/grub/"
+  case "$RELEASE" in
+    lenny|squeeze|wheezy)
+      cp "${MNTPOINT}"/usr/lib/grub/i386-pc/* "${MNTPOINT}/boot/grub/"
+      ;;
+    *)
+      cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
+      ;;
+  esac
   chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
   dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=4
   rm -f "${MNTPOINT}/tmp/core.img"
 
   einfo "Updating grub configuration file."
+  if [ -n "$BOOT_APPEND" ] ; then
+     sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}"/etc/default/grub
+  fi
   chroot "${MNTPOINT}" update-grub
 
+  case "$RELEASE" in
+    lenny|squeeze|wheezy)
+      einfo "Adjusting grub.cfg for successful boot sequence."
+      sed -i "s;root=[^ ]\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
+      ;;
+  esac
+
   umount "${MNTPOINT}"/proc
   umount "${MNTPOINT}"/sys
   umount "${MNTPOINT}"/dev
-
-  einfo "Adjusting grub.cfg for successful boot sequence."
-  # ugly but needed to boot grub acordingly
-  sed -i "s;set root=.*;set root='(hd0,msdos1)';" "${MNTPOINT}"/boot/grub/grub.cfg
-  sed -i "s; root=/dev/.*; root=/dev/sda1;" "${MNTPOINT}"/boot/grub/grub.cfg
-
   umount "${MNTPOINT}"
   kpartx -d "${ORIG_TARGET}" >/dev/null
 }
@@ -997,19 +1137,34 @@ debootstrap_system() {
   fi
 
   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
-     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
-     if [ -n "$MIRROR" ] ; then
-        einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
-        $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR
-     else
-        einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
-        $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
-     fi
-     eend $?
+    :
   else
-     eerror "Error: $MNTPOINT not mounted, can not continue."
-     eend 1
+    eerror "Error: $MNTPOINT not mounted, can not continue."
+    eend 1 ; exit 1
   fi
+
+  if [ -n "$ISO" ] ; then
+    einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
+    einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
+    "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
+    RC=$?
+  else
+    einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
+    einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
+    "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
+    RC=$?
+  fi
+
+  if [ $RC -ne 0 ] ; then
+    if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
+      [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
+      einfo "Presenting last ten lines of debootstrap.log:"
+      tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
+      einfo "End of debootstrap.log"
+    fi
+  fi
+
+  eend $RC
 }
 # }}}
 
@@ -1019,109 +1174,142 @@ preparechroot() {
 
   # provide variables to chroot system
   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
-  touch $CHROOT_VARIABLES
-  chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
-  echo "# Configuration of ${PN}"                              > $CHROOT_VARIABLES
-  [ -n "$ARCH" ]                && echo "ARCH=\"$ARCH\""                               >> $CHROOT_VARIABLES
-  [ -n "$CHROOT_SCRIPTS" ]      && echo "CHROOT_SCRIPTS=\"$CHROOT_SCRIPTS\""           >> $CHROOT_VARIABLES
-  [ -n "$CONFFILES" ]           && echo "CONFFILES=\"$CONFFILES\""                     >> $CHROOT_VARIABLES
-  [ -n "$DEBCONF" ]             && echo "DEBCONF=\"$DEBCONF\""                         >> $CHROOT_VARIABLES
-  [ -n "$DEBIAN_FRONTEND" ]     && echo "DEBIAN_FRONTEND=\"$DEBIAN_FRONTEND\""         >> $CHROOT_VARIABLES
-  [ -n "$DEBOOTSTRAP" ]         && echo "DEBOOTSTRAP=\"$DEBOOTSTRAP\""                 >> $CHROOT_VARIABLES
-  [ -n "$EXTRAPACKAGES" ]       && echo "EXTRAPACKAGES=\"$EXTRAPACKAGES\""             >> $CHROOT_VARIABLES
-  [ -n "$FORCE" ]               && echo "FORCE=\"$FORCE\""                             >> $CHROOT_VARIABLES
-  [ -n "$GRMLREPOS" ]           && echo "GRMLREPOS=\"$GRMLREPOS\""                     >> $CHROOT_VARIABLES
-  [ -n "$GRUB" ]                && echo "GRUB=\"$GRUB\""                               >> $CHROOT_VARIABLES
-  [ -n "$HOSTNAME" ]            && echo "HOSTNAME=\"$HOSTNAME\""                       >> $CHROOT_VARIABLES
-  [ -n "$INITRD" ]              && echo "INITRD=\"$INITRD\""                           >> $CHROOT_VARIABLES
-  [ -n "$INSTALL_NOTES" ]       && echo "INSTALL_NOTES=\"$INSTALL_NOTES\""             >> $CHROOT_VARIABLES
-  [ -n "$ISODIR" ]              && echo "ISODIR=\"$ISO\""                              >> $CHROOT_VARIABLES
-  [ -n "$ISO" ]                 && echo "ISO=\"$ISO\""                                 >> $CHROOT_VARIABLES
-  [ -n "$KEEP_SRC_LIST" ]       && echo "KEEP_SRC_LIST=\"$KEEP_SRC_LIST\""             >> $CHROOT_VARIABLES
-  [ -n "$LOCALES" ]             && echo "LOCALES=\"$LOCALES\""                         >> $CHROOT_VARIABLES
-  [ -n "$MIRROR" ]              && echo "MIRROR=\"$MIRROR\""                           >> $CHROOT_VARIABLES
-  [ -n "$MKFS" ]                && echo "MKFS=\"$MKFS\""                               >> $CHROOT_VARIABLES
-  [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                          >> $CHROOT_VARIABLES
-  [ -n "$PACKAGES" ]            && echo "PACKAGES=\"$PACKAGES\""                       >> $CHROOT_VARIABLES
-  [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS=\"$PRE_SCRIPTS\""                 >> $CHROOT_VARIABLES
-  [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE=\"$RECONFIGURE\""                 >> $CHROOT_VARIABLES
-  [ -n "$RELEASE" ]             && echo "RELEASE=\"$RELEASE\""                         >> $CHROOT_VARIABLES
-  [ -n "$RM_APTCACHE" ]         && echo "RM_APTCACHE=\"$RM_APTCACHE\""                 >> $CHROOT_VARIABLES
-  [ -n "$ROOTPASSWORD" ]        && echo "ROOTPASSWORD=\"$ROOTPASSWORD\""               >> $CHROOT_VARIABLES
-  [ -n "$SCRIPTS" ]             && echo "SCRIPTS=\"$SCRIPTS\""                         >> $CHROOT_VARIABLES
-  [ -n "$SECURE" ]              && echo "SECURE=\"$SECURE\""                           >> $CHROOT_VARIABLES
-  [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS=\"$SELECTED_PARTITIONS\"" >> $CHROOT_VARIABLES
-  [ -n "$TARGET" ]              && echo "TARGET=\"$TARGET\""                           >> $CHROOT_VARIABLES
-  [ -n "$UPGRADE_SYSTEM" ]      && echo "UPGRADE_SYSTEM=\"$UPGRADE_SYSTEM\""           >> $CHROOT_VARIABLES
-  [ -n "$TARGET_UUID" ]         && echo "TARGET_UUID=\"$TARGET_UUID\""                 >> $CHROOT_VARIABLES
-  [ -n "$TIMEZONE" ]            && echo "TIMEZONE=\"$TIMEZONE\""                       >> $CHROOT_VARIABLES
-  [ -n "$TUNE2FS" ]             && echo "TUNE2FS=\"$TUNE2FS\""                         >> $CHROOT_VARIABLES
-  [ -n "$VMSIZE" ]              && echo "VMSIZE=\"$VMSIZE\""                           >> $CHROOT_VARIABLES
-
-  cp $VERBOSE $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
-  chmod 755 $MNTPOINT/bin/chroot-script
+  touch "$CHROOT_VARIABLES"
+  chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
+  echo "# Configuration of ${PN}"                              > "$CHROOT_VARIABLES"
+  [ -n "$ARCH" ]                && echo "ARCH=\"$ARCH\""                               >> "$CHROOT_VARIABLES"
+  [ -n "$BACKPORTREPOS" ]       && echo "BACKPORTREPOS=\"$BACKPORTREPOS\""             >> "$CHROOT_VARIABLES"
+  [ -n "$CHROOT_SCRIPTS" ]      && echo "CHROOT_SCRIPTS=\"$CHROOT_SCRIPTS\""           >> "$CHROOT_VARIABLES"
+  [ -n "$CONFFILES" ]           && echo "CONFFILES=\"$CONFFILES\""                     >> "$CHROOT_VARIABLES"
+  [ -n "$DEBCONF" ]             && echo "DEBCONF=\"$DEBCONF\""                         >> "$CHROOT_VARIABLES"
+  [ -n "$DEBIAN_FRONTEND" ]     && echo "DEBIAN_FRONTEND=\"$DEBIAN_FRONTEND\""         >> "$CHROOT_VARIABLES"
+  [ -n "$DEBOOTSTRAP" ]         && echo "DEBOOTSTRAP=\"$DEBOOTSTRAP\""                 >> "$CHROOT_VARIABLES"
+  [ -n "$DEFAULT_LOCALES" ]     && echo "DEFAULT_LOCALES=\"$DEFAULT_LOCALES\""         >> "$CHROOT_VARIABLES"
+  [ -n "$DEFAULT_LANGUAGE" ]    && echo "DEFAULT_LANGUAGE=\"$DEFAULT_LANGUAGE\""       >> "$CHROOT_VARIABLES"
+  [ -n "$EXTRAPACKAGES" ]       && echo "EXTRAPACKAGES=\"$EXTRAPACKAGES\""             >> "$CHROOT_VARIABLES"
+  [ -n "$FALLBACK_MIRROR" ]     && echo "FALLBACK_MIRROR=\"$FALLBACK_MIRROR\""         >> "$CHROOT_VARIABLES"
+  [ -n "$FORCE" ]               && echo "FORCE=\"$FORCE\""                             >> "$CHROOT_VARIABLES"
+  [ -n "$GRMLREPOS" ]           && echo "GRMLREPOS=\"$GRMLREPOS\""                     >> "$CHROOT_VARIABLES"
+  [ -n "$GRUB" ]                && echo "GRUB=\"$GRUB\""                               >> "$CHROOT_VARIABLES"
+  [ -n "$HOSTNAME" ]            && echo "HOSTNAME=\"$HOSTNAME\""                       >> "$CHROOT_VARIABLES"
+  [ -n "$INITRD" ]              && echo "INITRD=\"$INITRD\""                           >> "$CHROOT_VARIABLES"
+  [ -n "$INSTALL_NOTES" ]       && echo "INSTALL_NOTES=\"$INSTALL_NOTES\""             >> "$CHROOT_VARIABLES"
+  [ -n "$ISODIR" ]              && echo "ISODIR=\"$ISO\""                              >> "$CHROOT_VARIABLES"
+  [ -n "$ISO" ]                 && echo "ISO=\"$ISO\""                                 >> "$CHROOT_VARIABLES"
+  [ -n "$KEEP_SRC_LIST" ]       && echo "KEEP_SRC_LIST=\"$KEEP_SRC_LIST\""             >> "$CHROOT_VARIABLES"
+  [ -n "$LOCALES" ]             && echo "LOCALES=\"$LOCALES\""                         >> "$CHROOT_VARIABLES"
+  [ -n "$MIRROR" ]              && echo "MIRROR=\"$MIRROR\""                           >> "$CHROOT_VARIABLES"
+  [ -n "$MKFS" ]                && echo "MKFS=\"$MKFS\""                               >> "$CHROOT_VARIABLES"
+  [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                          >> "$CHROOT_VARIABLES"
+  [ -n "$NOKERNEL" ]            && echo "NOKERNEL=\"true\""                            >> "$CHROOT_VARIABLES"
+  [ -n "$PACKAGES" ]            && echo "PACKAGES=\"$PACKAGES\""                       >> "$CHROOT_VARIABLES"
+  [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS=\"$PRE_SCRIPTS\""                 >> "$CHROOT_VARIABLES"
+  [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE=\"$RECONFIGURE\""                 >> "$CHROOT_VARIABLES"
+  [ -n "$RELEASE" ]             && echo "RELEASE=\"$RELEASE\""                         >> "$CHROOT_VARIABLES"
+  [ -n "$RM_APTCACHE" ]         && echo "RM_APTCACHE=\"$RM_APTCACHE\""                 >> "$CHROOT_VARIABLES"
+  [ -n "$ROOTPASSWORD" ]        && echo "ROOTPASSWORD=\"$ROOTPASSWORD\""               >> "$CHROOT_VARIABLES"
+  [ -n "$SCRIPTS" ]             && echo "SCRIPTS=\"$SCRIPTS\""                         >> "$CHROOT_VARIABLES"
+  [ -n "$SECURE" ]              && echo "SECURE=\"$SECURE\""                           >> "$CHROOT_VARIABLES"
+  [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS=\"$SELECTED_PARTITIONS\"" >> "$CHROOT_VARIABLES"
+  [ -n "$TARGET" ]              && echo "TARGET=\"$TARGET\""                           >> "$CHROOT_VARIABLES"
+  [ -n "$UPGRADE_SYSTEM" ]      && echo "UPGRADE_SYSTEM=\"$UPGRADE_SYSTEM\""           >> "$CHROOT_VARIABLES"
+  [ -n "$TARGET_UUID" ]         && echo "TARGET_UUID=\"$TARGET_UUID\""                 >> "$CHROOT_VARIABLES"
+  [ -n "$TIMEZONE" ]            && echo "TIMEZONE=\"$TIMEZONE\""                       >> "$CHROOT_VARIABLES"
+  [ -n "$TUNE2FS" ]             && echo "TUNE2FS=\"$TUNE2FS\""                         >> "$CHROOT_VARIABLES"
+  [ -n "$VMSIZE" ]              && echo "VMSIZE=\"$VMSIZE\""                           >> "$CHROOT_VARIABLES"
+
+  cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
+  chmod 755 "${MNTPOINT}"/bin/chroot-script
   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
 
   # make sure we have our files for later use via chroot-script
-  cp $VERBOSE $CONFFILES/config    $MNTPOINT/etc/debootstrap/
+  cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
   # make sure we adjust the configuration variables accordingly:
-  sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" $MNTPOINT/etc/debootstrap/config
-  sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    $MNTPOINT/etc/debootstrap/config
-  sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          $MNTPOINT/etc/debootstrap/config
+  sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
+  sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
+  sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
 
   # install notes:
   if [ -n "$INSTALL_NOTES" ] ; then
-     [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" $MNTPOINT/etc/debootstrap/
+     [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
   fi
 
   # package selection:
-  cp $VERBOSE ${_opt_packages:-$CONFFILES/packages} \
-    $MNTPOINT/etc/debootstrap/packages
+  cp $VERBOSE "${_opt_packages:-$CONFFILES/packages}" \
+    "${MNTPOINT}"/etc/debootstrap/packages
 
   # debconf preseeding:
   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
-  [ -f $_opt_debconf -a "$DEBCONF" = 'yes' ] && \
-    cp $VERBOSE $_opt_debconf $MNTPOINT/etc/debootstrap/debconf-selections
+  [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
+    cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
 
   # copy scripts that should be executed inside the chroot:
   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
-  [ -d $_opt_chroot_scripts -a "$CHROOT_SCRIPTS" = 'yes' ] && {
-    mkdir -p $MNTPOINT/etc/debootstrap/chroot-scripts
-    cp -a $VERBOSE $_opt_chroot_scripts/* $MNTPOINT/etc/debootstrap/chroot-scripts/
+  [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
+    mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
+    cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
   }
 
   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
-  cp $VERBOSE $CHROOT_VARIABLES  $MNTPOINT/etc/debootstrap/variables
+  cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
 
-  cp $VERBOSE -a -L $CONFFILES/extrapackages/ $MNTPOINT/etc/debootstrap/
+  cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
 
   # make sure we can access network [relevant for cdebootstrap]
-  [ -f "$MNTPOINT/etc/resolv.conf" ] || cp $VERBOSE /etc/resolv.conf $MNTPOINT/etc/resolv.conf
+  [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
 
   # provide system's /etc/hosts to the target:
   if ! [ -f "$MNTPOINT/etc/hosts" ] ; then
-     cp $VERBOSE /etc/hosts $MNTPOINT/etc/hosts
+     cp $VERBOSE /etc/hosts "${MNTPOINT}"/etc/hosts
   fi
 
   # setup default locales
-  [ -n "$LOCALES" ] && cp $VERBOSE $CONFFILES/locale.gen  $MNTPOINT/etc/locale.gen
+  [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
 
   # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
-  ( cd $MNTPOINT/dev && tar zxf /etc/debootstrap/devices.tar.gz )
+  ( cd "${MNTPOINT}"/dev && tar zxf /etc/debootstrap/devices.tar.gz )
 
   # copy any existing files to chroot
-  [ -d $CONFFILES/bin   ] && cp $VERBOSE -a -L $CONFFILES/bin/*   $MNTPOINT/bin/
-  [ -d $CONFFILES/boot  ] && cp $VERBOSE -a -L $CONFFILES/boot/*  $MNTPOINT/boot/
-  [ -d $CONFFILES/etc   ] && cp $VERBOSE -a -L $CONFFILES/etc/*   $MNTPOINT/etc/
-  [ -d $CONFFILES/sbin  ] && cp $VERBOSE -a -L $CONFFILES/sbin/*  $MNTPOINT/sbin/
-  [ -d $CONFFILES/share ] && cp $VERBOSE -a -L $CONFFILES/share/* $MNTPOINT/share/
-  [ -d $CONFFILES/usr   ] && cp $VERBOSE -a -L $CONFFILES/usr/*   $MNTPOINT/usr/
-  [ -d $CONFFILES/var   ] && cp $VERBOSE -a -L $CONFFILES/var/*   $MNTPOINT/var/
-
-  # copy local network setup to chroot
-  if [ -r /etc/network/interfaces -a ! -r "${MNTPOINT}"/etc/network/interfaces ] ; then
-     [ -d $MNTPOINT/etc/network ] || mkdir $MNTPOINT/etc/network
-     cp $VERBOSE /etc/network/interfaces $MNTPOINT/etc/network/interfaces
+  [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
+  [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
+  [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
+  [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
+  [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
+  [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
+  [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
+
+  # network setup
+  DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
+
+# Include files from /etc/network/interfaces.d when using
+# ifupdown v0.7.44 or newer:
+#source-directory /etc/network/interfaces.d
+
+auto lo
+iface lo inet loopback
+
+allow-hotplug eth0
+iface eth0 inet dhcp
+"
+
+  if [ -n "$NOINTERFACES" ] ; then
+    einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option" ; eend 0
+  elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
+    einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
+    echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
+    eend $?
+  elif [ -n "$VIRTUAL" ] ; then
+    einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
+    echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
+    eend $?
+  elif [ -r /etc/network/interfaces ] ; then
+    einfo "Copying /etc/network/interfaces from host to target system"
+    cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
+    eend $?
+  else
+    ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
+    echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
+    eend $?
   fi
 
   # install config file providing some example entries
@@ -1165,21 +1353,56 @@ execute_scripts() {
 }
 # }}}
 
+try_umount() {
+  local tries=$1
+  local mountpoint="$2"
+
+  for (( try=1; try<=tries; try++ )); do
+    if [[ ${try} -eq ${tries} ]]; then
+      # Last time, show errors this time
+      umount "${mountpoint}" && return 0
+    else
+      # Not last time, hide errors until fatal
+      if umount "${mountpoint}" 2>/dev/null ; then
+        return 0
+      else
+        sleep 1
+      fi
+    fi
+  done
+  return 1  # Tried enough
+}
+
 # execute chroot-script {{{
 chrootscript() {
   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
-     mount_target
+    mount_target
   fi
 
-  if [ -x "$MNTPOINT/bin/chroot-script" ] ; then
-     einfo "Executing chroot-script now"
-     mount --bind /dev "$MNTPOINT"/dev
-     chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
-     umount "$MNTPOINT"/dev
-     eend $RC
+  if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
+    eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
+    eend 1
   else
-     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
-     eend 1
+    einfo "Executing chroot-script now"
+    mount --bind /dev "$MNTPOINT"/dev
+    if [ "$DEBUG" = "true" ] ; then
+      chroot "$MNTPOINT" /bin/sh -x /bin/chroot-script ; RC=$?
+    else
+      chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
+    fi
+    try_umount 3 "$MNTPOINT"/dev
+    eend $RC
+  fi
+
+  # finally get rid of chroot-script again, there's no good reason to
+  # keep it on the installed system
+  if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
+    einfo "Removing chroot-script again"
+    rm -f "${MNTPOINT}/bin/chroot-script"
+    eend $?
+  else
+    einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
+    eend 0
   fi
 }
 # }}}
@@ -1203,7 +1426,7 @@ umount_chroot() {
   if grep -q "$MNTPOINT" /proc/mounts ; then
      if [ -n "$PARTITION" ] ; then
         einfo "Unmount $MNTPOINT"
-        umount $MNTPOINT
+        umount "$MNTPOINT"
         eend $?
      fi
   fi
@@ -1213,14 +1436,14 @@ umount_chroot() {
 # execute filesystem check {{{
 fscktool() {
  if [ -n "$VIRTUAL" ] ; then
-   einfo "Skipping filesystem check since we deploy a virtual machine."
+   einfo "Skipping filesystem check because we deploy a virtual machine."
    return 0
  fi
 
  if [ "$FSCK" = 'yes' ] ; then
    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
-   $FSCKTOOL $TARGET
+   "$FSCKTOOL" "$TARGET"
    eend $?
  fi
 }
@@ -1231,19 +1454,15 @@ for i in prepare_vm mkfs tunefs mount_target debootstrap_system \
          preparechroot execute_pre_scripts chrootscript execute_scripts \
          umount_chroot finalize_vm fscktool ; do
     if stage "${i}" ; then
-       $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "i"
+      if "$i" ; then
+        stage "${i}" 'done' && rm -f "${STAGES}/${i}"
+      else
+        bailout 2 "$i"
+      fi
     fi
 done
-# }}}
 
-# finalize {{{
-einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
-einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
-
-# Remove temporary mountpoint again
-if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
-   einfo "Removing directory ${MNTPOINT}" ; rmdir "$MNTPOINT" ; eend $?
-fi
+cleanup
 # }}}
 
 # end dialog of autoinstallation {{{